Create a construction phase plan
curl --request POST \
--url https://api.ctrl-hub.com/v3/construction-phase-plans \
--header 'Content-Type: application/vnd.api+json' \
--header 'X-Session-Token: <api-key>' \
--data '
{
"data": {
"type": "construction-phase-plans",
"attributes": {
"health_and_safety_aims": {
"aims": "<string>"
},
"site_rules": {
"rules": [
"<string>"
]
},
"induction": {
"points": [
"<string>"
],
"declarations": [
"<string>"
]
},
"welfare": {
"toilets": "<string>",
"washing": "<string>",
"drinking_water": "<string>",
"rest_and_eating": "<string>",
"changing_and_drying": "<string>",
"location": "<string>"
},
"emergency_arrangements": {
"emergency_procedures": "<string>",
"fire_arrangements": "<string>",
"first_aid_arrangements": "<string>",
"first_aiders": [
{
"name": "<string>",
"user_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
],
"nearest_hospital": "<string>"
},
"monitoring_and_review": {
"arrangements": "<string>",
"review_frequency": "<string>"
},
"key_operatives": [
{
"name": "<string>",
"role": "<string>",
"phone": "<string>",
"user_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"job_role_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
]
}
}
}
'import requests
url = "https://api.ctrl-hub.com/v3/construction-phase-plans"
payload = { "data": {
"type": "construction-phase-plans",
"attributes": {
"health_and_safety_aims": { "aims": "<string>" },
"site_rules": { "rules": ["<string>"] },
"induction": {
"points": ["<string>"],
"declarations": ["<string>"]
},
"welfare": {
"toilets": "<string>",
"washing": "<string>",
"drinking_water": "<string>",
"rest_and_eating": "<string>",
"changing_and_drying": "<string>",
"location": "<string>"
},
"emergency_arrangements": {
"emergency_procedures": "<string>",
"fire_arrangements": "<string>",
"first_aid_arrangements": "<string>",
"first_aiders": [
{
"name": "<string>",
"user_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
],
"nearest_hospital": "<string>"
},
"monitoring_and_review": {
"arrangements": "<string>",
"review_frequency": "<string>"
},
"key_operatives": [
{
"name": "<string>",
"role": "<string>",
"phone": "<string>",
"user_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"job_role_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
]
}
} }
headers = {
"X-Session-Token": "<api-key>",
"Content-Type": "application/vnd.api+json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'X-Session-Token': '<api-key>', 'Content-Type': 'application/vnd.api+json'},
body: JSON.stringify({
data: {
type: 'construction-phase-plans',
attributes: {
health_and_safety_aims: {aims: '<string>'},
site_rules: {rules: ['<string>']},
induction: {points: ['<string>'], declarations: ['<string>']},
welfare: {
toilets: '<string>',
washing: '<string>',
drinking_water: '<string>',
rest_and_eating: '<string>',
changing_and_drying: '<string>',
location: '<string>'
},
emergency_arrangements: {
emergency_procedures: '<string>',
fire_arrangements: '<string>',
first_aid_arrangements: '<string>',
first_aiders: [{name: '<string>', user_id: '3c90c3cc-0d44-4b50-8888-8dd25736052a'}],
nearest_hospital: '<string>'
},
monitoring_and_review: {arrangements: '<string>', review_frequency: '<string>'},
key_operatives: [
{
name: '<string>',
role: '<string>',
phone: '<string>',
user_id: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
job_role_id: '3c90c3cc-0d44-4b50-8888-8dd25736052a'
}
]
}
}
})
};
fetch('https://api.ctrl-hub.com/v3/construction-phase-plans', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.ctrl-hub.com/v3/construction-phase-plans",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'data' => [
'type' => 'construction-phase-plans',
'attributes' => [
'health_and_safety_aims' => [
'aims' => '<string>'
],
'site_rules' => [
'rules' => [
'<string>'
]
],
'induction' => [
'points' => [
'<string>'
],
'declarations' => [
'<string>'
]
],
'welfare' => [
'toilets' => '<string>',
'washing' => '<string>',
'drinking_water' => '<string>',
'rest_and_eating' => '<string>',
'changing_and_drying' => '<string>',
'location' => '<string>'
],
'emergency_arrangements' => [
'emergency_procedures' => '<string>',
'fire_arrangements' => '<string>',
'first_aid_arrangements' => '<string>',
'first_aiders' => [
[
'name' => '<string>',
'user_id' => '3c90c3cc-0d44-4b50-8888-8dd25736052a'
]
],
'nearest_hospital' => '<string>'
],
'monitoring_and_review' => [
'arrangements' => '<string>',
'review_frequency' => '<string>'
],
'key_operatives' => [
[
'name' => '<string>',
'role' => '<string>',
'phone' => '<string>',
'user_id' => '3c90c3cc-0d44-4b50-8888-8dd25736052a',
'job_role_id' => '3c90c3cc-0d44-4b50-8888-8dd25736052a'
]
]
]
]
]),
CURLOPT_HTTPHEADER => [
"Content-Type: application/vnd.api+json",
"X-Session-Token: <api-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.ctrl-hub.com/v3/construction-phase-plans"
payload := strings.NewReader("{\n \"data\": {\n \"type\": \"construction-phase-plans\",\n \"attributes\": {\n \"health_and_safety_aims\": {\n \"aims\": \"<string>\"\n },\n \"site_rules\": {\n \"rules\": [\n \"<string>\"\n ]\n },\n \"induction\": {\n \"points\": [\n \"<string>\"\n ],\n \"declarations\": [\n \"<string>\"\n ]\n },\n \"welfare\": {\n \"toilets\": \"<string>\",\n \"washing\": \"<string>\",\n \"drinking_water\": \"<string>\",\n \"rest_and_eating\": \"<string>\",\n \"changing_and_drying\": \"<string>\",\n \"location\": \"<string>\"\n },\n \"emergency_arrangements\": {\n \"emergency_procedures\": \"<string>\",\n \"fire_arrangements\": \"<string>\",\n \"first_aid_arrangements\": \"<string>\",\n \"first_aiders\": [\n {\n \"name\": \"<string>\",\n \"user_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n }\n ],\n \"nearest_hospital\": \"<string>\"\n },\n \"monitoring_and_review\": {\n \"arrangements\": \"<string>\",\n \"review_frequency\": \"<string>\"\n },\n \"key_operatives\": [\n {\n \"name\": \"<string>\",\n \"role\": \"<string>\",\n \"phone\": \"<string>\",\n \"user_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"job_role_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n }\n ]\n }\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("X-Session-Token", "<api-key>")
req.Header.Add("Content-Type", "application/vnd.api+json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.ctrl-hub.com/v3/construction-phase-plans")
.header("X-Session-Token", "<api-key>")
.header("Content-Type", "application/vnd.api+json")
.body("{\n \"data\": {\n \"type\": \"construction-phase-plans\",\n \"attributes\": {\n \"health_and_safety_aims\": {\n \"aims\": \"<string>\"\n },\n \"site_rules\": {\n \"rules\": [\n \"<string>\"\n ]\n },\n \"induction\": {\n \"points\": [\n \"<string>\"\n ],\n \"declarations\": [\n \"<string>\"\n ]\n },\n \"welfare\": {\n \"toilets\": \"<string>\",\n \"washing\": \"<string>\",\n \"drinking_water\": \"<string>\",\n \"rest_and_eating\": \"<string>\",\n \"changing_and_drying\": \"<string>\",\n \"location\": \"<string>\"\n },\n \"emergency_arrangements\": {\n \"emergency_procedures\": \"<string>\",\n \"fire_arrangements\": \"<string>\",\n \"first_aid_arrangements\": \"<string>\",\n \"first_aiders\": [\n {\n \"name\": \"<string>\",\n \"user_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n }\n ],\n \"nearest_hospital\": \"<string>\"\n },\n \"monitoring_and_review\": {\n \"arrangements\": \"<string>\",\n \"review_frequency\": \"<string>\"\n },\n \"key_operatives\": [\n {\n \"name\": \"<string>\",\n \"role\": \"<string>\",\n \"phone\": \"<string>\",\n \"user_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"job_role_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n }\n ]\n }\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.ctrl-hub.com/v3/construction-phase-plans")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["X-Session-Token"] = '<api-key>'
request["Content-Type"] = 'application/vnd.api+json'
request.body = "{\n \"data\": {\n \"type\": \"construction-phase-plans\",\n \"attributes\": {\n \"health_and_safety_aims\": {\n \"aims\": \"<string>\"\n },\n \"site_rules\": {\n \"rules\": [\n \"<string>\"\n ]\n },\n \"induction\": {\n \"points\": [\n \"<string>\"\n ],\n \"declarations\": [\n \"<string>\"\n ]\n },\n \"welfare\": {\n \"toilets\": \"<string>\",\n \"washing\": \"<string>\",\n \"drinking_water\": \"<string>\",\n \"rest_and_eating\": \"<string>\",\n \"changing_and_drying\": \"<string>\",\n \"location\": \"<string>\"\n },\n \"emergency_arrangements\": {\n \"emergency_procedures\": \"<string>\",\n \"fire_arrangements\": \"<string>\",\n \"first_aid_arrangements\": \"<string>\",\n \"first_aiders\": [\n {\n \"name\": \"<string>\",\n \"user_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n }\n ],\n \"nearest_hospital\": \"<string>\"\n },\n \"monitoring_and_review\": {\n \"arrangements\": \"<string>\",\n \"review_frequency\": \"<string>\"\n },\n \"key_operatives\": [\n {\n \"name\": \"<string>\",\n \"role\": \"<string>\",\n \"phone\": \"<string>\",\n \"user_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"job_role_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n }\n ]\n }\n }\n}"
response = http.request(request)
puts response.read_body{
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "construction-phase-plans",
"attributes": {
"health_and_safety_aims": {
"aims": "<string>"
},
"site_rules": {
"rules": [
"<string>"
]
},
"induction": {
"points": [
"<string>"
],
"declarations": [
"<string>"
]
},
"welfare": {
"toilets": "<string>",
"washing": "<string>",
"drinking_water": "<string>",
"rest_and_eating": "<string>",
"changing_and_drying": "<string>",
"location": "<string>"
},
"emergency_arrangements": {
"emergency_procedures": "<string>",
"fire_arrangements": "<string>",
"first_aid_arrangements": "<string>",
"first_aiders": [
{
"name": "<string>",
"user_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
],
"nearest_hospital": "<string>"
},
"monitoring_and_review": {
"arrangements": "<string>",
"review_frequency": "<string>"
},
"key_operatives": [
{
"name": "<string>",
"role": "<string>",
"phone": "<string>",
"user_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"job_role_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
],
"client_checklist": {
"management_arrangements": {
"answer": "yes",
"comments": "<string>"
},
"time_and_resources": {
"answer": "yes",
"comments": "<string>"
},
"pre_construction_information": {
"answer": "yes",
"comments": "<string>"
},
"principal_designer_appointed": {
"answer": "yes",
"comments": "<string>"
},
"principal_contractor_appointed": {
"answer": "yes",
"comments": "<string>"
},
"construction_phase_plan_in_place": {
"answer": "yes",
"comments": "<string>"
},
"welfare_provided": {
"answer": "yes",
"comments": "<string>"
},
"health_and_safety_file_arranged": {
"answer": "yes",
"comments": "<string>"
},
"notification_made": {
"answer": "yes",
"comments": "<string>"
},
"competence_checked": {
"answer": "yes",
"comments": "<string>"
}
},
"attestations": [
{
"section": "<string>",
"acting_role": "client_and_principal_designer",
"attested_at": "2023-11-07T05:31:56Z",
"attested_by_type": "users",
"attested_by_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"revision": 123,
"organisation_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
],
"current_revision": 123,
"access": {
"acting_role": "client_and_principal_designer",
"writable_sections": [
"<string>"
],
"owned_sections": [
"<string>"
],
"can_hand_over": true,
"can_propose_changes": true
},
"created_at": "2023-11-07T05:31:56Z",
"updated_at": "2023-11-07T05:31:56Z",
"handed_over_at": "2023-11-07T05:31:56Z",
"key_operatives_drift": {
"unposted": [
{
"user_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"job_role_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
],
"unlisted": [
{
"user_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"job_role_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
]
}
},
"relationships": {
"organisation": {
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "organisations"
}
},
"scheme": {
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "schemes"
}
},
"pre_construction_information": {
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "pre-construction-informations"
}
},
"principal_contractor": {
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "organisations"
}
},
"media_folder": {
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "folders"
}
}
}
},
"jsonapi": {
"version": "1.0"
},
"included": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "schemes",
"attributes": {
"name": "<string>",
"status": "in_planning",
"code": "<string>",
"description": "<string>",
"dates": {
"anticipated": {
"start": "2023-11-07T05:31:56Z",
"end": "2023-11-07T05:31:56Z"
}
},
"labels": [
{
"key": "Your label key",
"value": "Your label value"
}
]
},
"meta": {
"created_at": "2023-11-07T05:31:56Z",
"updated_at": "2023-11-07T05:31:56Z",
"modified_at": "2023-11-07T05:31:56Z",
"from_template": true,
"dates": {
"scheduled": {
"start": "2023-11-07T05:31:56Z",
"end": "2023-11-07T05:31:56Z"
}
},
"counts": {
"operations": 0,
"permits": 0,
"properties": 0,
"locations": 0,
"streets": 0,
"work_orders": 0
},
"completeness": {
"percentage": {
"completed": 0,
"aborted": 0,
"unknown": 100,
"cancelled": 0
},
"counts": {
"completed": 0,
"aborted": 0,
"unknown": 1,
"cancelled": 0
},
"statuses": {
"counts": {
"done": 0,
"in_progress": 0,
"todo": 0
},
"percentages": {
"done": 0,
"in_progress": 0,
"todo": 0
}
},
"done_reasons": {
"counts": {
"aborted": 0,
"cancelled": 0,
"completed": 0
},
"percentages": {
"aborted": 0,
"cancelled": 0,
"completed": 0
}
}
},
"is_default": false,
"imported_at": "2023-11-07T05:31:56Z"
},
"relationships": {
"organisation": {
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "organisations"
}
},
"scheme_template": {
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "scheme-templates"
}
},
"work_orders": {
"data": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "work-orders"
}
]
},
"template": {
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "scheme-templates"
}
},
"site_managers": {
"data": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "users"
}
]
},
"assignees": {
"data": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "users"
}
]
},
"teams": {
"data": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "teams"
}
]
},
"folder": {
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "folders"
}
},
"contracts": {
"data": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "scheme-contracts"
}
]
},
"locations": {
"data": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "locations"
}
]
},
"created_by_user": {
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "users"
}
},
"created_by_service_account": {
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "service-accounts"
}
}
}
}
]
}{
"id": "98ca4a78-b66f-4234-9719-aaf832ee6669",
"status": "400",
"title": "A validation error was encountered",
"source": {
"parameter": "include"
},
"meta": {
"resource": "wrong_value"
}
}{
"id": "05fc9c8d-73b9-4697-9337-57f7a567a48f",
"status": "401",
"title": "You are not authorised to access this resource",
"detail": "In order to access this resource, you need the 'admin' role.",
"code": "AUTH.001"
}{
"errors": [
{
"id": "1b3f2c30-2d56-4d3a-9c44-9be9c2cbf2f0",
"status": "403",
"title": "Forbidden",
"detail": "You do not hold the grant required for this action.",
"code": "AUTH.002"
}
]
}{
"id": "7b4c8f12-3e9a-4d5b-8c6f-1a2b3c4d5e6f",
"status": "404",
"title": "Resource not found",
"detail": "The requested resource could not be found or does not exist.",
"code": "NOT_FOUND.001"
}{
"id": "8e2f9a34-b5c6-4d7e-9f8a-2b3c4d5e6f7g",
"status": "409",
"title": "Conflict",
"detail": "The request conflicts with the current state of the resource.",
"code": "CONFLICT.001"
}{
"id": "fe9d9a69-f0a7-4fdc-bb2c-176027f316c5",
"status": "500",
"title": "Internal Server Error",
"detail": "An unexpected error occurred on the server."
}Construction Phase Plans
Create a construction phase plan
Create a construction phase plan. See the request body for who can.
POST
/
v3
/
construction-phase-plans
Create a construction phase plan
curl --request POST \
--url https://api.ctrl-hub.com/v3/construction-phase-plans \
--header 'Content-Type: application/vnd.api+json' \
--header 'X-Session-Token: <api-key>' \
--data '
{
"data": {
"type": "construction-phase-plans",
"attributes": {
"health_and_safety_aims": {
"aims": "<string>"
},
"site_rules": {
"rules": [
"<string>"
]
},
"induction": {
"points": [
"<string>"
],
"declarations": [
"<string>"
]
},
"welfare": {
"toilets": "<string>",
"washing": "<string>",
"drinking_water": "<string>",
"rest_and_eating": "<string>",
"changing_and_drying": "<string>",
"location": "<string>"
},
"emergency_arrangements": {
"emergency_procedures": "<string>",
"fire_arrangements": "<string>",
"first_aid_arrangements": "<string>",
"first_aiders": [
{
"name": "<string>",
"user_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
],
"nearest_hospital": "<string>"
},
"monitoring_and_review": {
"arrangements": "<string>",
"review_frequency": "<string>"
},
"key_operatives": [
{
"name": "<string>",
"role": "<string>",
"phone": "<string>",
"user_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"job_role_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
]
}
}
}
'import requests
url = "https://api.ctrl-hub.com/v3/construction-phase-plans"
payload = { "data": {
"type": "construction-phase-plans",
"attributes": {
"health_and_safety_aims": { "aims": "<string>" },
"site_rules": { "rules": ["<string>"] },
"induction": {
"points": ["<string>"],
"declarations": ["<string>"]
},
"welfare": {
"toilets": "<string>",
"washing": "<string>",
"drinking_water": "<string>",
"rest_and_eating": "<string>",
"changing_and_drying": "<string>",
"location": "<string>"
},
"emergency_arrangements": {
"emergency_procedures": "<string>",
"fire_arrangements": "<string>",
"first_aid_arrangements": "<string>",
"first_aiders": [
{
"name": "<string>",
"user_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
],
"nearest_hospital": "<string>"
},
"monitoring_and_review": {
"arrangements": "<string>",
"review_frequency": "<string>"
},
"key_operatives": [
{
"name": "<string>",
"role": "<string>",
"phone": "<string>",
"user_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"job_role_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
]
}
} }
headers = {
"X-Session-Token": "<api-key>",
"Content-Type": "application/vnd.api+json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'X-Session-Token': '<api-key>', 'Content-Type': 'application/vnd.api+json'},
body: JSON.stringify({
data: {
type: 'construction-phase-plans',
attributes: {
health_and_safety_aims: {aims: '<string>'},
site_rules: {rules: ['<string>']},
induction: {points: ['<string>'], declarations: ['<string>']},
welfare: {
toilets: '<string>',
washing: '<string>',
drinking_water: '<string>',
rest_and_eating: '<string>',
changing_and_drying: '<string>',
location: '<string>'
},
emergency_arrangements: {
emergency_procedures: '<string>',
fire_arrangements: '<string>',
first_aid_arrangements: '<string>',
first_aiders: [{name: '<string>', user_id: '3c90c3cc-0d44-4b50-8888-8dd25736052a'}],
nearest_hospital: '<string>'
},
monitoring_and_review: {arrangements: '<string>', review_frequency: '<string>'},
key_operatives: [
{
name: '<string>',
role: '<string>',
phone: '<string>',
user_id: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
job_role_id: '3c90c3cc-0d44-4b50-8888-8dd25736052a'
}
]
}
}
})
};
fetch('https://api.ctrl-hub.com/v3/construction-phase-plans', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.ctrl-hub.com/v3/construction-phase-plans",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'data' => [
'type' => 'construction-phase-plans',
'attributes' => [
'health_and_safety_aims' => [
'aims' => '<string>'
],
'site_rules' => [
'rules' => [
'<string>'
]
],
'induction' => [
'points' => [
'<string>'
],
'declarations' => [
'<string>'
]
],
'welfare' => [
'toilets' => '<string>',
'washing' => '<string>',
'drinking_water' => '<string>',
'rest_and_eating' => '<string>',
'changing_and_drying' => '<string>',
'location' => '<string>'
],
'emergency_arrangements' => [
'emergency_procedures' => '<string>',
'fire_arrangements' => '<string>',
'first_aid_arrangements' => '<string>',
'first_aiders' => [
[
'name' => '<string>',
'user_id' => '3c90c3cc-0d44-4b50-8888-8dd25736052a'
]
],
'nearest_hospital' => '<string>'
],
'monitoring_and_review' => [
'arrangements' => '<string>',
'review_frequency' => '<string>'
],
'key_operatives' => [
[
'name' => '<string>',
'role' => '<string>',
'phone' => '<string>',
'user_id' => '3c90c3cc-0d44-4b50-8888-8dd25736052a',
'job_role_id' => '3c90c3cc-0d44-4b50-8888-8dd25736052a'
]
]
]
]
]),
CURLOPT_HTTPHEADER => [
"Content-Type: application/vnd.api+json",
"X-Session-Token: <api-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.ctrl-hub.com/v3/construction-phase-plans"
payload := strings.NewReader("{\n \"data\": {\n \"type\": \"construction-phase-plans\",\n \"attributes\": {\n \"health_and_safety_aims\": {\n \"aims\": \"<string>\"\n },\n \"site_rules\": {\n \"rules\": [\n \"<string>\"\n ]\n },\n \"induction\": {\n \"points\": [\n \"<string>\"\n ],\n \"declarations\": [\n \"<string>\"\n ]\n },\n \"welfare\": {\n \"toilets\": \"<string>\",\n \"washing\": \"<string>\",\n \"drinking_water\": \"<string>\",\n \"rest_and_eating\": \"<string>\",\n \"changing_and_drying\": \"<string>\",\n \"location\": \"<string>\"\n },\n \"emergency_arrangements\": {\n \"emergency_procedures\": \"<string>\",\n \"fire_arrangements\": \"<string>\",\n \"first_aid_arrangements\": \"<string>\",\n \"first_aiders\": [\n {\n \"name\": \"<string>\",\n \"user_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n }\n ],\n \"nearest_hospital\": \"<string>\"\n },\n \"monitoring_and_review\": {\n \"arrangements\": \"<string>\",\n \"review_frequency\": \"<string>\"\n },\n \"key_operatives\": [\n {\n \"name\": \"<string>\",\n \"role\": \"<string>\",\n \"phone\": \"<string>\",\n \"user_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"job_role_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n }\n ]\n }\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("X-Session-Token", "<api-key>")
req.Header.Add("Content-Type", "application/vnd.api+json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.ctrl-hub.com/v3/construction-phase-plans")
.header("X-Session-Token", "<api-key>")
.header("Content-Type", "application/vnd.api+json")
.body("{\n \"data\": {\n \"type\": \"construction-phase-plans\",\n \"attributes\": {\n \"health_and_safety_aims\": {\n \"aims\": \"<string>\"\n },\n \"site_rules\": {\n \"rules\": [\n \"<string>\"\n ]\n },\n \"induction\": {\n \"points\": [\n \"<string>\"\n ],\n \"declarations\": [\n \"<string>\"\n ]\n },\n \"welfare\": {\n \"toilets\": \"<string>\",\n \"washing\": \"<string>\",\n \"drinking_water\": \"<string>\",\n \"rest_and_eating\": \"<string>\",\n \"changing_and_drying\": \"<string>\",\n \"location\": \"<string>\"\n },\n \"emergency_arrangements\": {\n \"emergency_procedures\": \"<string>\",\n \"fire_arrangements\": \"<string>\",\n \"first_aid_arrangements\": \"<string>\",\n \"first_aiders\": [\n {\n \"name\": \"<string>\",\n \"user_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n }\n ],\n \"nearest_hospital\": \"<string>\"\n },\n \"monitoring_and_review\": {\n \"arrangements\": \"<string>\",\n \"review_frequency\": \"<string>\"\n },\n \"key_operatives\": [\n {\n \"name\": \"<string>\",\n \"role\": \"<string>\",\n \"phone\": \"<string>\",\n \"user_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"job_role_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n }\n ]\n }\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.ctrl-hub.com/v3/construction-phase-plans")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["X-Session-Token"] = '<api-key>'
request["Content-Type"] = 'application/vnd.api+json'
request.body = "{\n \"data\": {\n \"type\": \"construction-phase-plans\",\n \"attributes\": {\n \"health_and_safety_aims\": {\n \"aims\": \"<string>\"\n },\n \"site_rules\": {\n \"rules\": [\n \"<string>\"\n ]\n },\n \"induction\": {\n \"points\": [\n \"<string>\"\n ],\n \"declarations\": [\n \"<string>\"\n ]\n },\n \"welfare\": {\n \"toilets\": \"<string>\",\n \"washing\": \"<string>\",\n \"drinking_water\": \"<string>\",\n \"rest_and_eating\": \"<string>\",\n \"changing_and_drying\": \"<string>\",\n \"location\": \"<string>\"\n },\n \"emergency_arrangements\": {\n \"emergency_procedures\": \"<string>\",\n \"fire_arrangements\": \"<string>\",\n \"first_aid_arrangements\": \"<string>\",\n \"first_aiders\": [\n {\n \"name\": \"<string>\",\n \"user_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n }\n ],\n \"nearest_hospital\": \"<string>\"\n },\n \"monitoring_and_review\": {\n \"arrangements\": \"<string>\",\n \"review_frequency\": \"<string>\"\n },\n \"key_operatives\": [\n {\n \"name\": \"<string>\",\n \"role\": \"<string>\",\n \"phone\": \"<string>\",\n \"user_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"job_role_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n }\n ]\n }\n }\n}"
response = http.request(request)
puts response.read_body{
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "construction-phase-plans",
"attributes": {
"health_and_safety_aims": {
"aims": "<string>"
},
"site_rules": {
"rules": [
"<string>"
]
},
"induction": {
"points": [
"<string>"
],
"declarations": [
"<string>"
]
},
"welfare": {
"toilets": "<string>",
"washing": "<string>",
"drinking_water": "<string>",
"rest_and_eating": "<string>",
"changing_and_drying": "<string>",
"location": "<string>"
},
"emergency_arrangements": {
"emergency_procedures": "<string>",
"fire_arrangements": "<string>",
"first_aid_arrangements": "<string>",
"first_aiders": [
{
"name": "<string>",
"user_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
],
"nearest_hospital": "<string>"
},
"monitoring_and_review": {
"arrangements": "<string>",
"review_frequency": "<string>"
},
"key_operatives": [
{
"name": "<string>",
"role": "<string>",
"phone": "<string>",
"user_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"job_role_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
],
"client_checklist": {
"management_arrangements": {
"answer": "yes",
"comments": "<string>"
},
"time_and_resources": {
"answer": "yes",
"comments": "<string>"
},
"pre_construction_information": {
"answer": "yes",
"comments": "<string>"
},
"principal_designer_appointed": {
"answer": "yes",
"comments": "<string>"
},
"principal_contractor_appointed": {
"answer": "yes",
"comments": "<string>"
},
"construction_phase_plan_in_place": {
"answer": "yes",
"comments": "<string>"
},
"welfare_provided": {
"answer": "yes",
"comments": "<string>"
},
"health_and_safety_file_arranged": {
"answer": "yes",
"comments": "<string>"
},
"notification_made": {
"answer": "yes",
"comments": "<string>"
},
"competence_checked": {
"answer": "yes",
"comments": "<string>"
}
},
"attestations": [
{
"section": "<string>",
"acting_role": "client_and_principal_designer",
"attested_at": "2023-11-07T05:31:56Z",
"attested_by_type": "users",
"attested_by_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"revision": 123,
"organisation_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
],
"current_revision": 123,
"access": {
"acting_role": "client_and_principal_designer",
"writable_sections": [
"<string>"
],
"owned_sections": [
"<string>"
],
"can_hand_over": true,
"can_propose_changes": true
},
"created_at": "2023-11-07T05:31:56Z",
"updated_at": "2023-11-07T05:31:56Z",
"handed_over_at": "2023-11-07T05:31:56Z",
"key_operatives_drift": {
"unposted": [
{
"user_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"job_role_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
],
"unlisted": [
{
"user_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"job_role_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
]
}
},
"relationships": {
"organisation": {
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "organisations"
}
},
"scheme": {
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "schemes"
}
},
"pre_construction_information": {
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "pre-construction-informations"
}
},
"principal_contractor": {
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "organisations"
}
},
"media_folder": {
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "folders"
}
}
}
},
"jsonapi": {
"version": "1.0"
},
"included": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "schemes",
"attributes": {
"name": "<string>",
"status": "in_planning",
"code": "<string>",
"description": "<string>",
"dates": {
"anticipated": {
"start": "2023-11-07T05:31:56Z",
"end": "2023-11-07T05:31:56Z"
}
},
"labels": [
{
"key": "Your label key",
"value": "Your label value"
}
]
},
"meta": {
"created_at": "2023-11-07T05:31:56Z",
"updated_at": "2023-11-07T05:31:56Z",
"modified_at": "2023-11-07T05:31:56Z",
"from_template": true,
"dates": {
"scheduled": {
"start": "2023-11-07T05:31:56Z",
"end": "2023-11-07T05:31:56Z"
}
},
"counts": {
"operations": 0,
"permits": 0,
"properties": 0,
"locations": 0,
"streets": 0,
"work_orders": 0
},
"completeness": {
"percentage": {
"completed": 0,
"aborted": 0,
"unknown": 100,
"cancelled": 0
},
"counts": {
"completed": 0,
"aborted": 0,
"unknown": 1,
"cancelled": 0
},
"statuses": {
"counts": {
"done": 0,
"in_progress": 0,
"todo": 0
},
"percentages": {
"done": 0,
"in_progress": 0,
"todo": 0
}
},
"done_reasons": {
"counts": {
"aborted": 0,
"cancelled": 0,
"completed": 0
},
"percentages": {
"aborted": 0,
"cancelled": 0,
"completed": 0
}
}
},
"is_default": false,
"imported_at": "2023-11-07T05:31:56Z"
},
"relationships": {
"organisation": {
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "organisations"
}
},
"scheme_template": {
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "scheme-templates"
}
},
"work_orders": {
"data": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "work-orders"
}
]
},
"template": {
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "scheme-templates"
}
},
"site_managers": {
"data": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "users"
}
]
},
"assignees": {
"data": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "users"
}
]
},
"teams": {
"data": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "teams"
}
]
},
"folder": {
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "folders"
}
},
"contracts": {
"data": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "scheme-contracts"
}
]
},
"locations": {
"data": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "locations"
}
]
},
"created_by_user": {
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "users"
}
},
"created_by_service_account": {
"data": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "service-accounts"
}
}
}
}
]
}{
"id": "98ca4a78-b66f-4234-9719-aaf832ee6669",
"status": "400",
"title": "A validation error was encountered",
"source": {
"parameter": "include"
},
"meta": {
"resource": "wrong_value"
}
}{
"id": "05fc9c8d-73b9-4697-9337-57f7a567a48f",
"status": "401",
"title": "You are not authorised to access this resource",
"detail": "In order to access this resource, you need the 'admin' role.",
"code": "AUTH.001"
}{
"errors": [
{
"id": "1b3f2c30-2d56-4d3a-9c44-9be9c2cbf2f0",
"status": "403",
"title": "Forbidden",
"detail": "You do not hold the grant required for this action.",
"code": "AUTH.002"
}
]
}{
"id": "7b4c8f12-3e9a-4d5b-8c6f-1a2b3c4d5e6f",
"status": "404",
"title": "Resource not found",
"detail": "The requested resource could not be found or does not exist.",
"code": "NOT_FOUND.001"
}{
"id": "8e2f9a34-b5c6-4d7e-9f8a-2b3c4d5e6f7g",
"status": "409",
"title": "Conflict",
"detail": "The request conflicts with the current state of the resource.",
"code": "CONFLICT.001"
}{
"id": "fe9d9a69-f0a7-4fdc-bb2c-176027f316c5",
"status": "500",
"title": "Internal Server Error",
"detail": "An unexpected error occurred on the server."
}Authorizations
SessionOAuth2Cookie
Session token for authentication.
Body
application/vnd.api+json
Create the scheme's Construction Phase Plan. Only the nominated Principal Contractor can, and only once the scheme has its Pre-Construction Information. The client checklist is the Client's and cannot be written here.
Show child attributes
Show child attributes
Response
A construction phase plan.
JSON API response object
The Principal Contractor's Construction Phase Plan for a scheme, written from its Pre-Construction Information. A scheme has at most one.
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Related resources that can be included with a construction phase plan
Show child attributes
Show child attributes